//+------------------------------------------------------------------+
//| ATR_Bound_EA.mq4
//| Copyright  2008
//| http://www.forex-tsd.com/expert-advisors-metatrader-4/20393-atr-bound-ea.html
//| version 1.0
//+------------------------------------------------------------------+
#property copyright "Copyright  2008"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/20393-atr-bound-ea.html"

//---- input parameters
extern int  ATR_Period=14;
extern int  MA_Period=34;
extern double Risk = 0.02;
//---- local variables
static datetime last_time;
int Magic = 20090611;

int init()
{
   last_time = Time[0];
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   if(NewBar() )
   {
      double MA_1 = iMA(Symbol(), 0, MA_Period, 0, MODE_EMA, PRICE_CLOSE, 1);
      double MA_2 = iMA(Symbol(), 0, MA_Period, 0, MODE_EMA, PRICE_CLOSE, 2);
      double ATR = iATR(Symbol(), 0, ATR_Period, 1);
      if(!ActiveOrders())
      {
         //we have no open orders 
         double pip = MarketInfo(Symbol(), MODE_TICKVALUE);
         double lots = 0;
         if(MA_2<MA_1 && Open[1]<MA_1 && Close[1]>MA_1) //Moving averages slopes up, open below MA, close above MA
         {
            lots = NormalizeDouble((AccountBalance()*Risk)/(((Ask-(MA_1-ATR))/Point)*pip),2);
            OrderSend(Symbol(), OP_BUY, lots, Ask, 10, MA_1-ATR, MA_1+1.5*ATR, NULL, Magic); // open BUY order, slippage quite large to allow execution
         }
         if(MA_2>MA_1 && Open[1]>MA_1 && Close[1]<MA_1) //Moving averages slopes down, open above MA, close below MA
         {
            lots = NormalizeDouble((AccountBalance()*Risk)/(((MA_1+ATR-Bid)/Point)*pip),2);
            OrderSend(Symbol(), OP_SELL, lots, Bid, 10, MA_1+ATR, MA_1-1.5*ATR, NULL, Magic); // open SELL order, slippage quite large to allow execution
         }
      }
      else
      {
         //we have open orders 
         for(int i=0; i<OrdersTotal(); i++)
         {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol()) //we found our order 
            {
               if(OrderType()==OP_BUY)
               {
                  if(Close[1]<MA_1)
                     OrderClose(OrderTicket(), OrderLots(), Bid, 10);
                  else
                  {
                     //if(MA_1-ATR>OrderStopLoss())
                     //   OrderModify(OrderTicket(), NULL, MA_1-ATR, MA_1+1.5*ATR, NULL); //adjust stop loss 
                  }
               }
               if(OrderType()==OP_SELL)
               {
                  if(Close[1]>MA_1)
                     OrderClose(OrderTicket(), OrderLots(), Ask, 10);
                  else
                  {
                     //if(MA_1+ATR<OrderStopLoss())
                     //   OrderModify(OrderTicket(), NULL, MA_1+ATR, MA_1-1.5*ATR, NULL); //adjust stop loss 
                  }
               }
               break;
            }
        }
      }
   }   
   return(0);
}

bool NewBar()
{
   if(last_time != Time[0])
   {
      last_time = Time[0];
      return (true);
   }
   else
      return (false);
}

bool ActiveOrders()
{
   bool result = false;
   for(int i=0; i<OrdersTotal(); i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
      {
         result = true;
         break;
      }
   }
   return(result);
}